#include "ti86asm.inc"

.org _asm_exec_ram

; Sound Demo v1.0 - Created by Matthew Johnson

; EQUATES -------

#define   MONO          %11000000        ;Turns on both red and white wires
#define   OFF     		%11111100        ;Turns off both red and white wires
#define   LINK_PORT     7   		     ;address of com port



; DRAWS THE INTRODUCTION ------------------------------------------------------------------------
		
	res textwrite, (iy+new_grf_flgs)     ; Prevents from writing to graph buffer

	  xor a
	  ld (_penRow),a		
	  xor a
	  ld (_penCol),a	
	
	set textEraseBelow, (iy+textflags) 	; Draw line under inverted text
	set textInverse, (iy+textflags) 	; Inverted Text
	
      ld hl,Tintro 						; Puts title address in HL
	  call _vputs							; Display it
	
	res textInverse, (iy+textflags) 	; Back to normal

; DEMO BEGINS ---------------------------------------------------------------------------------

		di								; Disable Interrupts (Runs calc at full speed, less distortion)

; ====================================
; PLAY CRAZY SOUNDS USING Playtone
; ====================================

	ld a, (_penRow)
	add a, 8
	ld (_penRow), a

	xor a
	ld (_penCol),a	

	ld hl, Trandom
	call _vputs							; Display it

;--------------------------------------
Random: ; Uses r register for sorta random sounds
		ld a, r
		ld c, a
		ld hl, 150
		push bc
		call PlayTone
		pop bc
		djnz Random



		  ld a, (_penRow)
		  add a, 8
		  ld (_penRow), a

		  xor a
		  ld (_penCol),a	
	
		  ld hl, Tsiren
		  call _vputs							; Display it

		ld b, 10

;--------------------------------------
UltraCool:
		push bc


		ld b, 255
Cool1:  ; Frequency Increases
		ld c, b
		ld hl, 2	
		push bc
		call PlayTone
		pop bc
		djnz Cool1

;--------------------------------------	
		ld a, 0
		ld b, 255
Cool2:  ; Frequency Decreases (higher number, longer delay, lower frequency)
		inc a
		ld c, a

		ld hl, 2	

		push af
		push bc
		call PlayTone
		pop bc
		pop af

		djnz Cool2

	
		pop bc
		djnz UltraCool	

		  ld a, (_penRow)
		  add a, 8
	      ld (_penRow), a

		  xor a
		  ld (_penCol),a	

		  ld hl, Trandomvar
		  call _vputs							; Display it


;--------------------------------------
; Hmm..

Cool3:
		ld a, r
		rra
		rra
        rra
		rra
		rra
		rra
		rra
		rra
		rra
		rra

		dec c
		dec c
		dec c
		dec c
		dec c
		dec c
		dec c

		add a, c

		ld c, a
		ld hl, 50	

		push af
		push bc
	    call PlayTone
		pop bc
		pop af

		djnz Cool3
;--------------------------------------

		  ld a, (_penRow)
		  add a, 8
		  ld (_penRow), a

  		  xor a
		  ld (_penCol),a	

		  ld hl, Tgoodbye
		  call _vputs							; Display it

		ei				; Enable Interrupts
		ret				; Outta here


;-----------------------------------------------------------------------------------------------
;
; PLAYTONE - Plays a tone
; 
; Input:
;   C = Frequency (Pitch of Sound, up to 255 where 255 is the lowest pitch)
;   HL = Duration (Length of Tone, up to 65,535) 
; 
; Output:
; 
;-----------------------------------------------------------------------------------------------

PlayTone:

		dec	HL
		
		xor a					; Clear a
		cp h					; Check if H is 0
		jr nz, Speaker_OFF 		

		xor a					; Clear A
		cp l					; Check if L is 0

		ret z		        	; Both H and L were zero, so HL = 0 and now we return

Speaker_OFF:
   		ld    A, OFF       	  
   		out   (LINK_PORT), A  	; Turn off both red and white wires
  	
		ld b, c
Delay1: djnz  Delay1          	; The larger B is, the higher the delay thus the lower the frequency
   
Speaker_ON:
   		ld  A, MONO				; Turn on both red and white wires
   		out (LINK_PORT), A      
                            	

		ld b, c
Delay2: djnz  Delay2          	; The larger B is, the higher the delay thus the lower the frequency

		jp PlayTone

;-------------------------------------------------------------------------------------------------------
	
Tintro:	 	.db "Matt Johnson's Sound Demo v1.0 ", 0
Trandom:	.db " Playing Random Sounds..", 0
Tsiren:		.db " Playing Siren", 0
Trandomvar:	.db " Playing weird random sounds :)", 0
Tgoodbye:	.db "See ya later, matt2000@gte.net", 0 
.end
